=== modified file 'configure.ac'
--- configure.ac	2008-12-01 01:40:26 +0000
+++ configure.ac	2008-12-01 17:53:42 +0000
@@ -1121,10 +1121,13 @@
 
 # Check definition of pthread_getspecific
 AC_CACHE_CHECK([args to pthread_getspecific], [mysql_cv_getspecific_args],
-  [AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#if !defined(_REENTRANT)
+  [AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
+#if !defined(_REENTRANT)
 #define _REENTRANT
 #endif
+#ifndef _POSIX_PTHREAD_SEMANTICS 
 #define _POSIX_PTHREAD_SEMANTICS 
+#endif
 #include <pthread.h> ]], [[ void *pthread_getspecific(pthread_key_t key);
 pthread_getspecific((pthread_key_t) NULL); ]])],
     [mysql_cv_getspecific_args=POSIX],
@@ -1137,8 +1140,13 @@
 
   # Check definition of pthread_mutex_init
   AC_CACHE_CHECK([args to pthread_mutex_init], [mysql_cv_mutex_init_args],
-    [AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[#define _REENTRANT
+    [AC_COMPILE_IFELSE([AC_LANG_PROGRAM([[
+#ifndef _REENTRANT
+#define _REENTRANT
+#endif
+#ifndef _POSIX_PTHREAD_SEMANTICS
 #define _POSIX_PTHREAD_SEMANTICS 
+#endif
 #include <pthread.h> ]], [[ 
   pthread_mutexattr_t attr;
   pthread_mutex_t mp;
@@ -1155,8 +1163,13 @@
 #---START: Used in for client configure
 # Check definition of readdir_r
 AC_CACHE_CHECK([args to readdir_r], [mysql_cv_readdir_r],
-  [AC_LINK_IFELSE([AC_LANG_PROGRAM([[#define _REENTRANT
+  [AC_LINK_IFELSE([AC_LANG_PROGRAM([[
+#ifndef _REENTRANT
+#define _REENTRANT
+#endif
+#ifndef _POSIX_PTHREAD_SEMANTICS 
 #define _POSIX_PTHREAD_SEMANTICS 
+#endif
 #include <pthread.h>
 #include <dirent.h>]], [[ int readdir_r(DIR *dirp, struct dirent *entry, struct dirent **result);
 readdir_r((DIR *) NULL, (struct dirent *) NULL, (struct dirent **) NULL); ]])],
@@ -1170,8 +1183,12 @@
 # Check definition of posix sigwait()
 AC_CACHE_CHECK([style of sigwait], [mysql_cv_sigwait],
   [AC_LINK_IFELSE([AC_LANG_PROGRAM([[
+#ifndef _REENTRANT
 #define _REENTRANT
+#endif
+#ifndef _POSIX_PTHREAD_SEMANTICS
 #define _POSIX_PTHREAD_SEMANTICS 
+#endif
 #include <pthread.h>
 #include <signal.h>
       ]], [[
@@ -1194,8 +1211,12 @@
 # Check definition of posix sigwait()
 AC_CACHE_CHECK([style of sigwait], [mysql_cv_sigwait],
   [AC_LINK_IFELSE([AC_LANG_PROGRAM([[
+#ifndef _REENTRANT
 #define _REENTRANT
+#endif
+#ifndef _POSIX_PTHREAD_SEMANTICS
 #define _POSIX_PTHREAD_SEMANTICS 
+#endif
 #include <pthread.h>
 #include <signal.h>
       ]], [[
@@ -1215,8 +1236,12 @@
 # Check if pthread_attr_setscope() exists
 AC_CACHE_CHECK([for pthread_attr_setscope], [mysql_cv_pthread_attr_setscope],
   [AC_LINK_IFELSE([AC_LANG_PROGRAM([[
+#ifndef _REENTRANT
 #define _REENTRANT
+#endif
+#ifndef _POSIX_PTHREAD_SEMANTICS
 #define _POSIX_PTHREAD_SEMANTICS 
+#endif
 #include <pthread.h>
       ]], [[
 pthread_attr_t thr_attr;

=== modified file 'extra/my_print_defaults.cc'
--- extra/my_print_defaults.cc	2008-11-26 05:12:21 +0000
+++ extra/my_print_defaults.cc	2008-12-01 17:53:42 +0000
@@ -90,9 +90,9 @@
   printf("\nExample usage:\n%s --defaults-file=example.cnf client mysql\n", my_progname);
 }
 
+extern "C"
 static bool
-get_one_option(int optid, const struct my_option *opt __attribute__((unused)),
-	       char *argument __attribute__((unused)))
+get_one_option(int optid, const struct my_option *, char *)
 {
   switch (optid) {
     case 'c':
@@ -178,5 +178,5 @@
   free((char*) load_default_groups);
   free_defaults(arguments);
 
-  exit(error);
+  return error;
 }

=== modified file 'extra/mysql_waitpid.cc'
--- extra/mysql_waitpid.cc	2008-11-26 05:12:21 +0000
+++ extra/mysql_waitpid.cc	2008-12-01 17:53:42 +0000
@@ -44,9 +44,9 @@
   { 0, 0, 0, 0, 0, 0, GET_NO_ARG, NO_ARG, 0, 0, 0, 0, 0, 0}
 };
 
+extern "C"
 static bool
-get_one_option(int optid, const struct my_option *opt __attribute__((unused)),
-	       char *argument __attribute__((unused)))
+get_one_option(int optid, const struct my_option *, char *)
 {
   switch(optid) {
   case 'V':

=== modified file 'mysys/charset-def.cc'
--- mysys/charset-def.cc	2008-11-07 00:35:38 +0000
+++ mysys/charset-def.cc	2008-12-01 17:53:42 +0000
@@ -44,7 +44,7 @@
 #endif /* HAVE_CHARSET_utf8mb4 */
 
 
-bool init_compiled_charsets(myf flags __attribute__((unused)))
+bool init_compiled_charsets(myf)
 {
   CHARSET_INFO *cs;
 

=== modified file 'mysys/charset.cc'
--- mysys/charset.cc	2008-11-07 00:35:38 +0000
+++ mysys/charset.cc	2008-12-01 17:53:42 +0000
@@ -151,7 +151,7 @@
   cs->state|= MY_CS_AVAILABLE;
 }
 
-static void *cs_alloc(size_t size)
+void *cs_alloc(size_t size)
 {
   return my_once_alloc(size, MYF(MY_WME));
 }

=== modified file 'mysys/default.cc'
--- mysys/default.cc	2008-11-26 05:12:21 +0000
+++ mysys/default.cc	2008-12-01 17:53:42 +0000
@@ -51,8 +51,8 @@
 
 static const char *f_extensions[]= { ".cnf", 0 };
 
-static int handle_default_option(void *in_ctx, const char *group_name,
-                                 const char *option);
+int handle_default_option(void *in_ctx, const char *group_name,
+                          const char *option);
 
 /*
    This structure defines the context that we pass to callback
@@ -153,7 +153,7 @@
     load_defaults() as otherwise we can't know the type of 'func_ctx'
   */
 
-  if (my_defaults_group_suffix && func == handle_default_option)
+  if (my_defaults_group_suffix && (func == handle_default_option))
   {
     /* Handle --defaults-group-suffix= */
     uint32_t i;
@@ -235,7 +235,6 @@
 err:
   fprintf(stderr,"Fatal error in defaults handling. Program aborted\n");
   exit(1);
-  return 0;					/* Keep compiler happy */
 }
 
 
@@ -262,8 +261,8 @@
     1 - error occured
 */
 
-static int handle_default_option(void *in_ctx, const char *group_name,
-                                 const char *option)
+int handle_default_option(void *in_ctx, const char *group_name,
+                          const char *option)
 {
   char *tmp;
   struct handle_option_ctx *ctx= (struct handle_option_ctx *) in_ctx;
@@ -468,7 +467,6 @@
  err:
   fprintf(stderr,"Fatal error in defaults handling. Program aborted\n");
   exit(1);
-  return 0;					/* Keep compiler happy */
 }
 
 

=== modified file 'mysys/default_modify.cc'
--- mysys/default_modify.cc	2008-11-26 05:12:21 +0000
+++ mysys/default_modify.cc	2008-12-01 17:53:42 +0000
@@ -65,9 +65,10 @@
   struct stat file_stat;
   char linebuff[BUFF_SIZE], *src_ptr, *dst_ptr, *file_buffer;
   size_t opt_len= 0, optval_len= 0, sect_len;
-  uint32_t nr_newlines= 0, buffer_size;
+  uint32_t nr_newlines= 0;
+  size_t buffer_size;
   bool in_section= false, opt_applied= 0;
-  uint32_t reserve_extended;
+  size_t reserve_extended;
   uint32_t new_opt_len;
   int reserve_occupied= 0;
 
@@ -92,15 +93,14 @@
                      NEWLINE_LEN +              /* Space for newline */
                      RESERVE);                  /* Some additional space */
 
-  buffer_size= (file_stat.st_size +
-                1);                             /* The ending zero */
+  buffer_size= (size_t)cmax(file_stat.st_size + 1, SIZE_MAX);
 
   /*
     Reserve space to read the contents of the file and some more
     for the option we want to add.
   */
-  if (!(file_buffer= (char*) my_malloc(buffer_size + reserve_extended,
-                                       MYF(MY_WME))))
+  if (!(file_buffer= (char*) malloc(cmax(buffer_size + reserve_extended,
+                                         SIZE_MAX))))
     goto malloc_err;
 
   sect_len= strlen(section_name);

=== modified file 'mysys/mf_tempfile.cc'
--- mysys/mf_tempfile.cc	2008-11-26 05:12:21 +0000
+++ mysys/mf_tempfile.cc	2008-12-01 17:53:42 +0000
@@ -53,8 +53,8 @@
 */
 
 File create_temp_file(char *to, const char *dir, const char *prefix,
-		      int mode __attribute__((unused)),
-		      myf MyFlags __attribute__((unused)))
+		      int,
+		      myf MyFlags)
 {
   File file= -1;
 
@@ -104,6 +104,7 @@
   }
 #elif defined(HAVE_TEMPNAM)
   {
+    (void)MyFlags;
     char *res,**old_env,*temp_env[1];
     if (dir && !dir[0])
     {				/* Change empty string to current dir */

=== modified file 'mysys/mf_unixpath.cc'
--- mysys/mf_unixpath.cc	2008-11-07 00:35:38 +0000
+++ mysys/mf_unixpath.cc	2008-12-01 17:53:42 +0000
@@ -19,7 +19,7 @@
 	/* convert filename to unix style filename */
 	/* If MSDOS converts '\' to '/' */
 
-void to_unix_path(char * to __attribute__((unused)))
+void to_unix_path(char * to)
 {
 #if FN_LIBCHAR != '/'
   {
@@ -27,5 +27,7 @@
     while ((to=strchr(to+1,FN_LIBCHAR)) != 0)
       *to='/';
   }
+#else
+  (void)to;
 #endif
 }

=== modified file 'mysys/my_bitmap.cc'
--- mysys/my_bitmap.cc	2008-11-07 00:35:38 +0000
+++ mysys/my_bitmap.cc	2008-12-01 17:53:42 +0000
@@ -494,10 +494,8 @@
             if (*byte_ptr & (1 << k))
               return (i*32) + (j*8) + k;
           }
-          assert(0);
         }
       }
-      assert(0);
     }
   }
   return MY_BIT_NONE;
@@ -528,10 +526,8 @@
             if (!(*byte_ptr & (1 << k)))
               return (i*32) + (j*8) + k;
           }
-          assert(0);
         }
       }
-      assert(0);
     }
   }
   return MY_BIT_NONE;

=== modified file 'mysys/my_file.cc'
--- mysys/my_file.cc	2008-11-27 23:14:56 +0000
+++ mysys/my_file.cc	2008-12-01 17:53:42 +0000
@@ -43,24 +43,27 @@
 static uint32_t set_max_open_files(uint32_t max_file_limit)
 {
   struct rlimit rlimit;
-  uint32_t old_cur;
+  rlim_t old_cur;
 
   if (!getrlimit(RLIMIT_NOFILE,&rlimit))
   {
-    old_cur= (uint) rlimit.rlim_cur;
+    old_cur= rlimit.rlim_cur;
     if (rlimit.rlim_cur == RLIM_INFINITY)
       rlimit.rlim_cur = max_file_limit;
     if (rlimit.rlim_cur >= max_file_limit)
-      return(rlimit.rlim_cur);		/* purecov: inspected */
+      if (rlimit.rlim_cur > UINT32_MAX)
+        return UINT32_MAX;
+      else
+        return((uint32_t)rlimit.rlim_cur);
     rlimit.rlim_cur= rlimit.rlim_max= max_file_limit;
     if (setrlimit(RLIMIT_NOFILE, &rlimit))
-      max_file_limit= old_cur;			/* Use original value */
+      max_file_limit= (old_cur < UINT32_MAX) ? (uint32_t)old_cur : UINT32_MAX;
     else
     {
       rlimit.rlim_cur= 0;			/* Safety if next call fails */
       (void) getrlimit(RLIMIT_NOFILE,&rlimit);
       if (rlimit.rlim_cur)			/* If call didn't fail */
-	max_file_limit= (uint) rlimit.rlim_cur;
+	max_file_limit= (uint32_t) rlimit.rlim_cur;
     }
   }
   return(max_file_limit);
@@ -94,8 +97,7 @@
   if (files <= MY_NFILE)
     return(files);
 
-  if (!(tmp= (struct st_my_file_info*) my_malloc(sizeof(*tmp) * files,
-						 MYF(MY_WME))))
+  if (!(tmp= (st_my_file_info*) malloc(sizeof(st_my_file_info) * files)))
     return(MY_NFILE);
 
   /* Copy any initialized files */

=== modified file 'mysys/my_fstream.cc'
--- mysys/my_fstream.cc	2008-11-07 00:35:38 +0000
+++ mysys/my_fstream.cc	2008-12-01 17:53:42 +0000
@@ -112,9 +112,8 @@
 
 /* Seek to position in file */
 
-my_off_t my_fseek(FILE *stream, my_off_t pos, int whence,
-		  myf MyFlags __attribute__((unused)))
+my_off_t my_fseek(FILE *stream, my_off_t pos, int whence, myf)
 {
-  return(fseek(stream, (off_t) pos, whence) ?
+  return(fseeko(stream, (off_t) pos, whence) ?
 	      MY_FILEPOS_ERROR : (my_off_t) ftell(stream));
 } /* my_seek */

=== modified file 'mysys/my_gethwaddr.cc'
--- mysys/my_gethwaddr.cc	2008-11-07 00:35:38 +0000
+++ mysys/my_gethwaddr.cc	2008-12-01 17:53:42 +0000
@@ -103,7 +103,7 @@
 
 #else   /* FreeBSD elif linux */
 /* just fail */
-bool my_gethwaddr(unsigned char *to __attribute__((unused)))
+bool my_gethwaddr(unsigned char *)
 {
   return 1;
 }

=== modified file 'mysys/my_getopt.cc'
--- mysys/my_getopt.cc	2008-12-01 00:41:43 +0000
+++ mysys/my_getopt.cc	2008-12-01 17:53:42 +0000
@@ -31,7 +31,7 @@
 typedef void (*init_func_p)(const struct my_option *option, char **variable,
                             int64_t value);
 
-static void default_reporter(enum loglevel level, const char *format, ...);
+void default_reporter(enum loglevel level, const char *format, ...);
 my_error_reporter my_getopt_error_reporter= &default_reporter;
 
 static int findopt(char *optpat, uint32_t length,
@@ -80,8 +80,8 @@
 
 bool my_getopt_skip_unknown= 0;
 
-static void default_reporter(enum loglevel level,
-                             const char *format, ...)
+void default_reporter(enum loglevel level,
+                      const char *format, ...)
 {
   va_list args;
   va_start(args, format);
@@ -1051,7 +1051,7 @@
 */
 
 static void fini_one_value(const struct my_option *option, char **variable,
-			   int64_t value __attribute__ ((unused)))
+			   int64_t)
 {
   switch ((option->var_type & GET_TYPE_MASK)) {
   case GET_STR_ALLOC:

=== modified file 'mysys/my_getopt.h'
--- mysys/my_getopt.h	2008-12-01 00:41:43 +0000
+++ mysys/my_getopt.h	2008-12-01 17:53:42 +0000
@@ -72,6 +72,7 @@
 extern bool my_getopt_print_errors;
 extern bool my_getopt_skip_unknown;
 extern my_error_reporter my_getopt_error_reporter;
+void default_reporter(enum loglevel level, const char *format, ...);
 
 extern int handle_options (int *argc, char ***argv, 
 			   const struct my_option *longopts, my_get_one_option);

=== modified file 'mysys/my_getsystime.cc'
--- mysys/my_getsystime.cc	2008-11-07 00:35:38 +0000
+++ mysys/my_getsystime.cc	2008-12-01 17:53:42 +0000
@@ -60,10 +60,11 @@
 
 */
 
-time_t my_time(myf flags __attribute__((unused)))
+time_t my_time(myf flags)
 {
   time_t t;
 #ifdef HAVE_GETHRTIME
+  (void)flags;
   (void) my_micro_time_and_time(&t);
   return t;
 #else
@@ -195,9 +196,10 @@
     current time
 */
 
-time_t my_time_possible_from_micro(uint64_t microtime __attribute__((unused)))
+time_t my_time_possible_from_micro(uint64_t microtime)
 {
 #if defined(HAVE_GETHRTIME)
+  (void) microtime;
   return my_time(0);                            /* Cached time */
 #else
   return (time_t) (microtime / 1000000);

=== modified file 'mysys/my_init.cc'
--- mysys/my_init.cc	2008-11-29 00:09:36 +0000
+++ mysys/my_init.cc	2008-12-01 17:53:42 +0000
@@ -18,7 +18,6 @@
 #include <mysys/mysys_err.h>
 #include <mystrings/m_string.h>
 #include <mystrings/m_ctype.h>
-#include <signal.h>
 #include <stdio.h>
 #include <stdlib.h>
 

=== modified file 'mysys/my_messnc.cc'
--- mysys/my_messnc.cc	2008-11-26 05:12:21 +0000
+++ mysys/my_messnc.cc	2008-12-01 17:53:42 +0000
@@ -16,8 +16,7 @@
 #include "mysys_priv.h"
 #include <stdio.h>
 
-void my_message_no_curses(uint32_t error __attribute__((unused)),
-			 const char *str, myf MyFlags)
+void my_message_no_curses(uint32_t, const char *str, myf MyFlags)
 {
   (void) fflush(stdout);
   if (MyFlags & ME_BELL)

=== modified file 'mysys/my_pthread.h'
--- mysys/my_pthread.h	2008-11-27 23:14:56 +0000
+++ mysys/my_pthread.h	2008-12-01 17:53:42 +0000
@@ -20,6 +20,7 @@
 
 #include <stdint.h>
 #include <unistd.h>
+#include <signal.h>
 
 #if !defined(__cplusplus)
 # include <stdbool.h>

=== modified file 'mysys/my_seek.cc'
--- mysys/my_seek.cc	2008-11-07 00:35:38 +0000
+++ mysys/my_seek.cc	2008-12-01 17:53:42 +0000
@@ -42,8 +42,7 @@
                        actual error.
 */
 
-my_off_t my_seek(File fd, my_off_t pos, int whence,
-		 myf MyFlags __attribute__((unused)))
+my_off_t my_seek(File fd, my_off_t pos, int whence, myf)
 {
   register off_t newpos= -1;
   assert(pos != MY_FILEPOS_ERROR);		/* safety check */
@@ -74,7 +73,7 @@
 	/* Tell current position of file */
 	/* ARGSUSED */
 
-my_off_t my_tell(File fd, myf MyFlags __attribute__((unused)))
+my_off_t my_tell(File fd)
 {
   off_t pos;
   assert(fd >= 0);

=== modified file 'mysys/my_static.cc'
--- mysys/my_static.cc	2008-11-26 05:12:21 +0000
+++ mysys/my_static.cc	2008-12-01 17:53:42 +0000
@@ -73,11 +73,9 @@
 uint32_t my_time_to_wait_for_lock=2;	/* In seconds */
 
 	/* from errors.c */
-void (*my_abort_hook)(int) = (void(*)(int)) exit;
-void (*error_handler_hook)(uint32_t error,const char *str,myf MyFlags)=
-    my_message_no_curses;
-void (*fatal_error_handler_hook)(uint32_t error,const char *str,myf MyFlags)=
-  my_message_no_curses;
+void_ptr_int_func my_abort_hook= (void_ptr_int_func)exit;
+error_handler_func error_handler_hook= my_message_no_curses;
+error_handler_func fatal_error_handler_hook= my_message_no_curses;
 
 	/* How to disable options */
 bool my_disable_async_io=0;

=== modified file 'mysys/my_sync.cc'
--- mysys/my_sync.cc	2008-11-07 00:35:38 +0000
+++ mysys/my_sync.cc	2008-12-01 17:53:42 +0000
@@ -94,10 +94,9 @@
   RETURN
     0 if ok, !=0 if error
 */
-int my_sync_dir(const char *dir_name __attribute__((unused)),
-                myf my_flags __attribute__((unused)))
+#ifdef NEED_EXPLICIT_SYNC_DIR
+int my_sync_dir(const char *dir_name, myf my_flags)
 {
-#ifdef NEED_EXPLICIT_SYNC_DIR
   File dir_fd;
   int res= 0;
   const char *correct_dir_name;
@@ -117,10 +116,13 @@
   else
     res= 1;
   return(res);
+}
 #else
+int my_sync_dir(const char *, myf)
+{
   return 0;
+}
 #endif
-}
 
 
 /*
@@ -134,16 +136,18 @@
   RETURN
     0 if ok, !=0 if error
 */
-int my_sync_dir_by_file(const char *file_name __attribute__((unused)),
-                        myf my_flags __attribute__((unused)))
+#ifdef NEED_EXPLICIT_SYNC_DIR
+int my_sync_dir_by_file(const char *file_name, myf my_flags)
 {
-#ifdef NEED_EXPLICIT_SYNC_DIR
   char dir_name[FN_REFLEN];
   size_t dir_name_length;
   dirname_part(dir_name, file_name, &dir_name_length);
   return my_sync_dir(dir_name, my_flags);
+}
 #else
+int my_sync_dir_by_file(const char *, myf)
+{
   return 0;
+}
 #endif
-}
 

=== modified file 'mysys/my_sys.h'
--- mysys/my_sys.h	2008-11-29 00:09:36 +0000
+++ mysys/my_sys.h	2008-12-01 17:53:42 +0000
@@ -171,9 +171,9 @@
 extern char errbuff[NRERRBUFFS][ERRMSGSIZE];
 extern char *home_dir;			/* Home directory for user */
 extern const char *my_progname;		/* program-name (printed in errors) */
-extern void (*error_handler_hook)(uint32_t my_err, const char *str,myf MyFlags);
-extern void (*fatal_error_handler_hook)(uint32_t my_err, const char *str,
-                                        myf MyFlags);
+typedef void (*error_handler_func)(uint32_t my_err, const char *str,myf MyFlags);
+extern error_handler_func error_handler_hook;
+extern error_handler_func fatal_error_handler_hook;
 extern uint32_t my_file_limit;
 
 /* charsets */
@@ -187,11 +187,14 @@
 extern uint	mysys_usage_id;
 extern bool	my_init_done;
 
+typedef void (*void_ptr_func)(void);
+typedef void (*void_ptr_int_func)(int);
+
 					/* Point to current my_message() */
-extern void (*my_sigtstp_cleanup)(void),
+extern void_ptr_func my_sigtstp_cleanup,
 					/* Executed before jump to shell */
-	    (*my_sigtstp_restart)(void),
-	    (*my_abort_hook)(int);
+	    my_sigtstp_restart;
+extern void_ptr_int_func my_abort_hook;
 					/* Executed when comming from shell */
 extern int my_umask,		/* Default creation mask  */
 	   my_umask_dir,
@@ -333,6 +336,9 @@
 typedef int (*Process_option_func)(void *ctx, const char *group_name,
                                    const char *option);
 
+int handle_default_option(void *in_ctx, const char *group_name,
+                          const char *option);
+
 #include <mysys/my_alloc.h>
 
 
@@ -573,6 +579,8 @@
 #endif
 
 /* character sets */
+void *cs_alloc(size_t size);
+
 extern uint32_t get_charset_number(const char *cs_name, uint32_t cs_flags);
 extern uint32_t get_collation_number(const char *name);
 extern const char *get_charset_name(uint32_t cs_number);

=== modified file 'mysys/queues.cc'
--- mysys/queues.cc	2008-11-26 05:12:21 +0000
+++ mysys/queues.cc	2008-12-01 17:53:42 +0000
@@ -92,7 +92,7 @@
 */
 
 int init_queue_ex(QUEUE *queue, uint32_t max_elements, uint32_t offset_to_key,
-	       bool max_at_top, int (*compare) (void *, unsigned char *, unsigned char *),
+	       bool max_at_top, queue_compare compare,
 	       void *first_cmp_arg, uint32_t auto_extent)
 {
   int ret;
@@ -128,7 +128,7 @@
 */
 
 int reinit_queue(QUEUE *queue, uint32_t max_elements, uint32_t offset_to_key,
-		 bool max_at_top, int (*compare) (void *, unsigned char *, unsigned char *),
+		 bool max_at_top, queue_compare compare,
 		 void *first_cmp_arg)
 {
   queue->elements=0;

=== modified file 'mysys/thr_alarm.cc'
--- mysys/thr_alarm.cc	2008-11-26 05:12:21 +0000
+++ mysys/thr_alarm.cc	2008-12-01 17:53:42 +0000
@@ -67,10 +67,7 @@
 #define reschedule_alarms() pthread_kill(alarm_thread,THR_SERVER_ALARM)
 #endif
 
-static RETSIGTYPE thread_alarm(int sig __attribute__((unused)));
-
-static int compare_uint32_t(void *not_used __attribute__((unused)),
-			 unsigned char *a_ptr,unsigned char* b_ptr)
+int compare_uint32_t(void *, unsigned char *a_ptr,unsigned char* b_ptr)
 {
   uint32_t a=*((uint32_t*) a_ptr),b= *((uint32_t*) b_ptr);
   return (a < b) ? -1  : (a == b) ? 0 : 1;
@@ -323,7 +320,7 @@
 }
 
 
-static RETSIGTYPE process_alarm_part2(int sig __attribute__((unused)))
+static RETSIGTYPE process_alarm_part2(int)
 {
   ALARM *alarm_data;
 
@@ -503,7 +500,7 @@
 */
 
 
-static RETSIGTYPE thread_alarm(int sig)
+RETSIGTYPE thread_alarm(int sig)
 {
 #ifdef MAIN
   printf("thread_alarm\n"); fflush(stdout);

=== modified file 'mysys/thr_alarm.h'
--- mysys/thr_alarm.h	2008-10-06 06:47:29 +0000
+++ mysys/thr_alarm.h	2008-12-01 17:53:42 +0000
@@ -17,6 +17,9 @@
 
 #ifndef _thr_alarm_h
 #define _thr_alarm_h
+
+#include <signal.h>
+
 #ifdef	__cplusplus
 extern "C" {
 #endif
@@ -78,6 +81,9 @@
 extern uint32_t thr_client_alarm;
 extern pthread_t alarm_thread;
 
+int compare_uint32_t(void *unused, unsigned char *a_ptr,unsigned char* b_ptr);
+RETSIGTYPE thread_alarm(int sig);
+
 #define thr_alarm_init(A) (*(A))=0
 #define thr_alarm_in_use(A) (*(A)!= 0)
 void init_thr_alarm(uint32_t max_alarm);

